
Core - Bug # 55989

Status: Resolved Priority: Should have
Author: Thomas Skierlo Category: Indexed Search
Created: 2014-02-14 Assigned To:
Updated: 2014-03-12 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity: easy
Is Regression: Yes
Sprint Focus:
Subject: Debug "Column 'cookie' cannot be null"
Description

Function writeSearchStat of SearchFormController.php triggers a debug message in FE, because $this->fe_user->id resolves to NULL
and cookie is a non-null column.
(possibly the same will happen in SearchController.php)

$insertFields = array(
                        'searchstring' => $this->piVars['sword'],
                        'searchoptions' => serialize(array($this->piVars, $sWArr, $pt)),
                        'feuser_id' => (int)$this->fe_user->user['uid'],
                        // fe_user id, integer
                        'cookie' => $this->fe_user->id,
                        // cookie as set or retrieve. If people has cookies disabled this will vary all the time...
                        'IP' => GeneralUtility::getIndpEnv('REMOTE_ADDR'),
                        // Remote IP address
                        'hits' => (int)$count,
                        // Number of hits on the search.
                        'tstamp' => $GLOBALS['EXEC_TIME']
                );

This seems to have started after 6.2.0beta3

Related issues:
related to Core - Bug # 53662: DatabaseConnection INSERTquery does not allow ... Resolved 2013-11-15

Associated revisions
Revision 34fcdead - 2014-03-12 08:08 - Georg Ringer

[BUGFIX] Typecast cookie value to string

The cookie might be null, therefore the INSERTquery fails in
indexed_search.

As a solution, use a type cast to string.

Change-Id: If9e650ee713c75420859813546d138000b3023ff
Resolves: #55989
Releases: 6.2
Reviewed-by: Christian Kuhn
Reviewed-by: Tymoteusz Motylewski
Tested-by: Tymoteusz Motylewski
Reviewed-by: Georg Ringer
Tested-by: Georg Ringer

History
#1 - 2014-02-17 17:53 - Markus Klein
- Status changed from New to Accepted

This is due to the patch that allowed to insert NULL values into DB.

From time to time some place popup where the insert was not constructed properly, like here.

Can you push a patch?

#2 - 2014-02-17 17:54 - Markus Klein
- Complexity set to easy
- Is Regression changed from No to Yes

Target versions are all 6.x

#3 - 2014-03-12 07:30 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28281

#4 - 2014-03-12 08:30 - Georg Ringer
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:34fcdead654333f207ff479cf70fecb9d53e081b.
